From 6d066787d23c913789dcfc220b34cd3a78ada4c7 Mon Sep 17 00:00:00 2001
From: Julien Rische <jrische@redhat.com>
Date: Mon, 16 Feb 2026 16:30:14 +0100
Subject: [PATCH 18/21] Force "fork" method for RADIUS daemon in OTP test

The RADIUS daemon used in the OTP test relies on
multiprocessing.Process. Since Python 3.14, multiprocessing changed its
start method from "fork" to "forkserver". This method is not compatible
with the t_otp.py test.

This commit explicitly sets multiprocessing's start method to "fork" for
test t_otp.py, using multiprocessing.set_start_method() (available since
Python 3.4).

Pull-request: https://github.com/krb5/krb5/pull/1483
---
 src/tests/t_otp.py | 12 ++++++++----
 1 file changed, 8 insertions(+), 4 deletions(-)

diff --git a/src/tests/t_otp.py b/src/tests/t_otp.py
index dd5cdc5c26..c173b55c41 100755
--- a/src/tests/t_otp.py
+++ b/src/tests/t_otp.py
@@ -38,10 +38,14 @@ try:
 except ImportError:
     skip_rest('OTP tests', 'Python pyrad module not found')
 try:
-    from multiprocessing import Process, Queue
+    import multiprocessing
 except ImportError:
     skip_rest('OTP tests', 'Python version 2.6 required')
 
+# Since Python 3.14, "forkserver" replaces "fork" as default method on POSIX.
+# "forkserver" is not compatible with this test, so force the "fork" method.
+multiprocessing.set_start_method('fork', force=True)
+
 # We could use a dictionary file, but since we need so few attributes,
 # we'll just include them here.
 radius_attributes = '''
@@ -52,7 +56,7 @@ ATTRIBUTE    NAS-Identifier  32    string
 ATTRIBUTE    Message-Authenticator 80 octets
 '''
 
-class RadiusDaemon(Process):
+class RadiusDaemon(multiprocessing.Process):
     MAX_PACKET_SIZE = 4096
     DICTIONARY = dictionary.Dictionary(io.StringIO(radius_attributes))
 
@@ -186,7 +190,7 @@ conf = {'plugins': {'kdcpreauth': {'enable_only': 'otp'}},
                 'unix': {'server': socket_file,
                          'strip_realm': 'false'}}}
 
-queue = Queue()
+queue = multiprocessing.Queue()
 
 realm = K5Realm(kdc_conf=conf)
 realm.run([kadminl, 'modprinc', '+requires_preauth', realm.user_princ])
@@ -259,7 +263,7 @@ verify(daemon, queue, True, realm.user_princ, 'accept')
 ## tokens configured, with the first rejecting and the second
 ## accepting.  With the bug, the KDC incorrectly rejects the request
 ## and then performs invalid memory accesses, most likely crashing.
-queue2 = Queue()
+queue2 = multiprocessing.Queue()
 daemon1 = UDPRadiusDaemon(args=(server_addr, secret_file, 'accept1', queue))
 daemon2 = UnixRadiusDaemon(args=(socket_file, None, 'accept2', queue2))
 daemon1.start()
-- 
2.53.0


